compare <- function(v) {
  all(sapply( as.list(v[-1]), FUN=function(z) {identical(z, v[1])}))
} 
get.unique <- function(v) {
  u <- unique(v)
  check <- compare(c(u,v))
  if (check){
    return(u)
  } else {
    return(v)
    #cat("Press <Enter> to continue...")
    #invisible(readLines(file("stdin"), 1))
    cat("entries do not match in a vector.") 
  }
}
compare.vec <- function(u,v){
  n <- length(u)
  p <- length(v)
  check <- FALSE
  out <- NULL
  for (i_n in 1:n){
    for (j_p in 1:p){
      check <- all.equal.character(u[i_n],v[j_p])
      if (!is.logical(check)) {check <- FALSE}
      if (check){
        out <- u[i_n]
      }
    }
  }
  return(list(check=check,out=out))
}
check.close.strings <- function(vec,u){
  n <- length(vec)
  u1 <- str_sub(u, end=-2) # leave out last
  u2 <- str_sub(u, end=-3) # leave out last two
  #u3 <- str_sub(u, end=-4) # leave out last three
  u4 <- str_sub(u, start=2) # leave out first 
  u5 <- str_sub(u, start=3) # leave out first two
  #u6 <- str_sub(u, start=4) # leave out first three
  u.tmp <- c(u1,u4,u2,u5)#,u3,u6)
  id <- res <- all.idx <- where.true <- NULL
  check <- FALSE
  for (i_n in 1:n){
    v <- vec[i_n]
    v1 <- str_sub(v, end=-2) # leave out last
    v2 <- str_sub(v, end=-3) # leave out last two
    #v3 <- str_sub(v, end=-4) # leave out last three
    v4 <- str_sub(v, start=2) # leave out first 
    v5 <- str_sub(v, start=3) # leave out first two
    #v6 <- str_sub(v, start=4) # leave out first three
    v.tmp <- c(v1,v4,v2,v5)#,v3,v6)
    check.loop <- FALSE
    keep.track <- NULL
    for (j_tmp in 1:4){
      for (k_tmp in 1:4){
        if(is.logical(all.equal.character(u.tmp[j_tmp],v.tmp[k_tmp]))){
          check <- TRUE
          check.loop <- TRUE
          keep.track <- c(j_tmp,k_tmp)
          
        } else {
          
        }
      }
    }
    if (check.loop){
      where.true <- c(where.true,TRUE)
    } else {
      where.true <- c(where.true,FALSE)
    }
    all.idx <- rbind(all.idx,keep.track)
  }
  if (check){
    tmp <- rowSums(all.idx)
    idx <- min(which(tmp==min(tmp)))
    id <- which(where.true)[idx]
    res <- vec[id]
  } 
  return(list(check=check,res=res,id=id))
}

change.entry <- function(df,entry,entryNew){
  data.mtx <- as.matrix(df)
  idx <- which(as.matrix(data.mtx)==entry, arr.ind = TRUE)
  if(dim(idx)[1]>1){
    stop("more entries than 1")
  }
  data.mtx[idx] <- entryNew
  data.df <- as.data.frame(data.mtx)
  data.df
}