rm(list=ls())
# ------- SET WORKING DIRECTORY ------- #
if (! "rstudioapi" %in% installed.packages() ) install.packages("rstudioapi")
wd <- dirname(rstudioapi::getSourceEditorContext()$path)
setwd(wd)

if (! "readxl" %in% installed.packages() ) install.packages("readxl")
library(readxl)



list.filenames <- list.files(paste0(folder,"csv/"), pattern = ".csv")

for (i in 1:length(list.filenames)){
  cat(paste0(i, "-file has been processed. \n"))
  i.filename <- paste0(folder,"csv/",list.filenames[i])
  i.df <- read.csv(i.filename,
                   header = TRUE)
  i.filename.save <- paste0(folder,"rdata/",gsub(".csv",".RData",list.filenames[i]))
  save(i.df, file = i.filename.save)
}
