clear; clc

folder = '\RavenPack2020\zips\';
outputDir = '\RavenPack2020\csv\';

djsfiles = 2000:2019;
prfiles = 2004:2019;

filenames = cell(length(djsfiles)+length(prfiles));

for i = 1:length(djsfiles)
    filenames{i} = [folder,'djs',num2str(djsfiles(i)),'.7z'];
end

for j = (length(djsfiles)+1):(length(djsfiles)+length(prfiles))
    idx = j - length(djsfiles);
    filenames{j} = [folder,'pr',num2str(prfiles(idx)),'.7z'];
end

[status,result] = unzip_7z(filenames,outputDir);

function [status,result] = unzip_7z(filenames,outputDir)

n = length(filenames);
for f = 1:n
    [status,result] = system(['"C:\Program Files\7-Zip\7z.exe" -y x ' ...
    '"' convertStringsToChars(filenames{f}) '"' ' -o' '"' convertStringsToChars(outputDir) '"']);
end

end