rm(list=ls())
# ------- SET WORKING DIRECTORY ------- #
if (! "rstudioapi" %in% installed.packages() ) install.packages("rstudioapi")
wd <- dirname(rstudioapi::getSourceEditorContext()$path)
setwd(wd)

load("pe_ratio_ibes_crsp_ff.RData")

load("tickers.RData")

pe_ratio_ibes_crsp_ff_rp_filtered <- data.frame()

for (jj in seq(length(tickers))){
  i_tickers <- as.character(tickers[jj])
  tmp <- pe_ratio_ibes_crsp_ff[pe_ratio_ibes_crsp_ff$ticker%in%i_tickers,]
  pe_ratio_ibes_crsp_ff_rp_filtered <- rbind(pe_ratio_ibes_crsp_ff_rp_filtered, tmp)
}
pe_ratio_ibes_crsp_ff <- pe_ratio_ibes_crsp_ff_rp_filtered
pe_ratio_ibes_crsp_ff <- pe_ratio_ibes_crsp_ff[!pe_ratio_ibes_crsp_ff$ticker%in%"RIG",]
save(pe_ratio_ibes_crsp_ff, file = "pe_ratio_ibes_crsp_ff_rp_filtered.RData")